/*
 * Basic complex number arithmetics.
 *
 */

#ifndef COMPLEX_H_
#define COMPLEX_H_

typedef struct complex complex_t;

struct complex {
	double	re;
	double	im;
};

/* returns complex number with real and imaginary components */
complex_t c_num(double re, double im);

/* returns absolute value */
complex_t c_abs(complex_t a);

/* returns a / b */
complex_t c_div(complex_t a, complex_t b);

/* returns a + b */
complex_t c_sum(complex_t a, complex_t b);

/* returns a - b */
complex_t c_sub(complex_t a, complex_t b);

/* returns a * b */
complex_t c_mult(complex_t a, complex_t b);

//   
complex_t c_sqrt(complex_t a);

/* returns a scaled by scale. */
complex_t c_scale(complex_t a, double scale);

/* returns complex number by magnitude and phase. */
complex_t c_polar(double magnitude, double phase);

/* returns conjugate number to a */
complex_t c_conjugate(complex_t a);

/* returns magnitude a */
double c_magnitude(complex_t a);

/* returns phase of a */
double c_phase(complex_t a);

complex_t c_inverse(complex_t a);

complex_t c_sin(complex_t a);

complex_t c_cos(complex_t a);

complex_t c_asin(complex_t a);

complex_t c_acos(complex_t a);

#endif /* COMPLEX_H_ */
